#ifndef _HW_LAYOUT_H__
#define _HW_LAYOUT_H__

// This file is used to adapt the firmware to different hardware layouts.
// If you build your own layout, then you should add it here. Take a look
// at the included files below to see what you can configure there.


// Macros to read and write single I/O pins
#define writeBit(port,bit,value) { if ((value)>0) (port) |= (1<<bit); else (port) &= ~(1<<bit); } 
#define readBit(port,bit) (((port) >> (bit)) & 1)


// CrumbX1-NET version 1.0-1.2 from www.chip45.com
#ifdef CrumbX1_NET
    #include "hw-layout_CrumbX1_NET.h"
#endif


// CrumbX1-NET version 1.0-1.2 from www.chip45.com
// with a Bluetooth extenson.
#ifdef CrumbX1_NET_Bluetooth
    #include "hw-layout_CrumbX1_NET_Bluetooth.h"
#endif


// CrumbX1-NET version 1.0-1.2 from www.chip45.com
// with shift register extension.
#ifdef CrumbX1_NET_XL
    #include "hw-layout_CrumbX1_NET_XL.h"
#endif


// Crumb644-NET version 1.0 from www.chip45.com
#ifdef Crumb644_NET_v1
    #include "hw-layout_Crumb644_NET_v1.h"
#endif


// Crumb644-NET version 2.0 or 2.1 from www.chip45.com
#ifdef Crumb644_NET_v2
    #include "hw-layout_Crumb644_NET_v2.h"
#endif


// Crumb644-NET version 2.0 or 2.1 from www.chip45.com
// with shift register extension.
#ifdef Crumb644_NET_v2_XL
    #include "hw-layout_Crumb644_NET_v2_XL.h"
#endif


#endif // _HW_LAYOUT_H__
